<?php
/**
 * @category   Mageplaza
 * @package    Mageplaza_Helloworld
 * @author     prashant.bluethink@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Delivery\Management\Controller\Adminhtml\Items;

class Save extends \Magento\Backend\App\Action
{
    protected $_coreSession;
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        
        \Magento\Framework\Registry $coreRegistry,
        \Magento\Framework\Session\SessionManagerInterface $coreSession,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Delivery\Management\Model\ResourceModel\Management\CollectionFactory $collectionFactory,
        \Magento\Sales\Model\ResourceModel\Order\CollectionFactory $orderCollectionFactory 
    ) {
        parent::__construct($context);
        $this->_coreSession = $coreSession;
        $this->resultPageFactory = $resultPageFactory;
        $this->collectionFactory = $collectionFactory;
        $this->_orderCollectionFactory = $orderCollectionFactory;
    }
    public function execute()
    {
        
        if ($this->getRequest()->getPostValue()) {
            try {
                $collection = $this->_orderCollectionFactory->create();
                      echo "<pre>";
                       //print_r($collection->load());die;
                $orderCollection = $this->_coreSession->getDeliveryperson();

                $data = $this->getRequest()->getPostValue();
                $inputFilter = new \Zend_Filter_Input(
                    [],
                    [],
                    $data
                );
                $data = $inputFilter->getUnescaped();

                $getDeliverypicker = $data['entity'];
                
                foreach ($orderCollection as $key => $value) 
                {
                   $value->addData(array('delivery_picker'=>$getDeliverypicker));
                   $value->save();
                }
                

                
                $session = $this->_objectManager->get('Magento\Backend\Model\Session');
                
                $this->messageManager->addSuccess(__('You saved the item.'));
                $this->_redirect('delivery_management/items/readytodispatch');
                return;
            }catch (\Exception $e) {
                $this->_coreSession->unsDeliveryperson();
                $this->messageManager->addError(
                    __('Something went wrong while saving the item data. Please review the error log.')
                );
                $this->_objectManager->get('Psr\Log\LoggerInterface')->critical($e);
                $this->_redirect('delivery_management/*/edit', ['id' => $this->getRequest()->getParam('id')]);
                return;
            }
        }
        $this->_redirect('delivery_management/*/');
    }
}
